#include <linux/types.h>
#include <linux/sched.h>
#include <linux/timer.h>
#include <linux/netfilter.h>
#include "../ip_state_protocol.h"

#define GENERIC_TIMEOUT (3600*HZ)

static int generic_pkt_to_tuple(const void *datah, size_t datalen,
				struct ip_state_tuple *tuple)
{
	tuple->src.u.all = 0;
	tuple->dst.u.all = 0;

	return 1;
}

static int generic_invert_tuple(struct ip_state_tuple *tuple,
				const struct ip_state_tuple *orig)
{
	tuple->src.u.all = 0;
	tuple->dst.u.all = 0;

	return 1;
}

/* Print out the per-protocol part of the tuple. */
static unsigned int generic_print_tuple(char *buffer, 
					const struct ip_state_tuple *tuple)
{
	return 0;
}

/* Print out the private part of the state. */
static unsigned int generic_print_state(char *buffer, 
					const struct ip_state *state)
{
	return 0;
}

static void destroy(struct ip_state *state)
{
}

/* Returns verdict for packet, and may modify statetype */
static unsigned int established(struct ip_state *state,
				struct iphdr *iph, size_t len,
				int direction, enum ip_statetype *statetype)
{
	/* Refreshes connection for another hour. */
	mod_timer(&state->timeout, jiffies + GENERIC_TIMEOUT);

	return NF_ACCEPT;
}

/* Called when a new connection for this protocol found. */
static unsigned int new(struct ip_state *state,
			struct iphdr *iph, size_t len,
			enum ip_statetype *statetype)
{
	return NF_ACCEPT;
}

struct ip_state_protocol ip_state_generic_protocol
= { NULL, 0, "unknown", 0, generic_pkt_to_tuple, generic_invert_tuple, 
    generic_print_tuple, generic_print_state, destroy, established, new,
    GENERIC_TIMEOUT };

